#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {

    setName("Interactor for 'Board cutting' problem.");
    registerInteraction(argc, argv);

    int n = inf.readInt(), m = inf.readInt();
    int x = 1, y = 1;
    println(n, m);
    cout.flush();

    int top = x - 1, bottom = n - x, left = y - 1, right = m - y;
    auto hcut = [&](int i) {
        if (i <= top) top -= i;
        else bottom = i - top - 1;
    };
    auto vcut = [&](int i) {
        if (i <= left) left -= i;
        else right = i - left - 1;
    };

    auto play = [&]() {
        int full = left ^ right ^ top ^ bottom;
        if ((full ^ bottom) < bottom) {
            cout << "R " << (top + 1 + (full ^ bottom)) << '\n';
            bottom ^= full;
        } else if ((full ^ top) < top) {
            cout << "R " << (top - (full ^ top)) << '\n';
            top ^= full;
        } else if ((full ^ right) < right) {
            cout << "C " << (left + 1 + (full ^ right)) << '\n';
            right ^= full;
        } else if ((full ^ left) < left) {
            cout << "C " << (left - (full ^ left)) << '\n';
            left ^= full;
        } else {
            if (top + bottom > left + right) {
                if (top > bottom) {
                    cout << "R 1\n";
                    top--;
                } else {
                    cout << "R " << (top + bottom) << '\n';
                    bottom--;
                }
            } else {
                if (left > right) {
                    cout << "C 1\n";
                    left--;
                } else {
                    cout << "C " << (left + right) << '\n';
                    right--;
                }
            }
        }
        cout.flush();
    };

    int move = ouf.readInt(1, 2, "move");
    if (move == 2) play();

    pattern valid_type("[RC]"), valid_pos("[1-9][0-9]*");

    while (top > 0 || bottom > 0 || left > 0 || right > 0) {
        string type = ouf.readToken(), pos = ouf.readToken();
        int i = atoi(pos.c_str());
        if (!valid_type.matches(type) || !valid_pos.matches(pos) || i < 1 ||
            (type == "R" && i > top + bottom) || (type == "C" && i > left + right)) {
            cout << "FAIL\n";
            cout.flush();
            quitf(_wa, "Incorrect move: '%s %s' with n = %d and m = %d",
                  type.c_str(), pos.c_str(), top + bottom + 1, left + right + 1);
        }

        if (type == "R")
            hcut(i);
        else
            vcut(i);

        if (top == 0 && bottom == 0 && left == 0 && right == 0) {
            cout << "YOU WIN\n";
            cout.flush();
            quitf(_ok, "Participant won");
        } else {
            play();
        }
    }

}