#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

struct point {
    int x, y, no;

    bool operator<(point const &other) const {
        if (x != other.x) return x < other.x;
        if (y != other.y) return y < other.y;
        return no < other.no;
    }
};

istream &operator>>(istream &in, point &p) {
    static int no = 0;
    p.no = no++;
    return in >> p.x >> p.y;
}

typedef pair<ll, ll> res;

auto const LIM = 1'000'000'000ll;
auto const INF = res{-3ll * LIM, -1};

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 mt_rand(seed);
auto randint = bind(uniform_int_distribution<int>(-1e9, 1e9), mt_rand);

struct node;
typedef node *nodeptr;

struct node {
    int key, priority;
    nodeptr l = nullptr, r = nullptr;
    res self_up, self_down;
    res up, down;

    node(point const &p) :
            key(p.y), priority(randint()),
            self_up{p.x - p.y, p.no}, self_down{p.x + p.y, p.no} {
        up = self_up;
        down = self_down;
    }
};

res _up(nodeptr root) {
    return root ? root->up : INF;
}

res _down(nodeptr root) {
    return root ? root->down : INF;
}

nodeptr recalc(nodeptr root) {
    if (!root) return nullptr;
    root->up = max(root->self_up, max(_up(root->l), _up(root->r)));
    root->down = max(root->self_down, max(_down(root->l), _down(root->r)));
    return root;
}

pair<nodeptr, nodeptr> split(nodeptr root, int value) {
    if (!root) return {nullptr, nullptr};
    if (root->key < value) {
        auto [l, r] = split(root->r, value);
        root->r = l;
        return {recalc(root), r};
    } else {
        auto [l, r] = split(root->l, value);
        root->l = r;
        return {l, recalc(root)};
    }
}

nodeptr merge(nodeptr l, nodeptr r) {
    if (!l) return r;
    if (!r) return l;
    if (l->priority > r->priority) {
        l->r = merge(l->r, r);
        return recalc(l);
    } else {
        r->l = merge(l, r->l);
        return recalc(r);
    }
}

void insert(nodeptr &root, nodeptr item) {
    auto [l, r] = split(root, item->key);
    root = merge(merge(l, item), r);
}

#define all(c) c.begin(), c.end()

int main() {

    in(int, n)
    vector<point> pts(n);
    cin >> pts;

    sort(all(pts));
    vector<res> result(n, res(3 * LIM, -1));

    auto walk = [&]() {
        nodeptr root = nullptr;
        for (int i = 0; i < n; i++) {
            auto p = pts[i];
            auto [down, up] = split(root, p.y);
            ll mdown = p.x + p.y - _down(down).first, mup = p.x - p.y - _up(up).first;

            if (mdown < result[p.no].first)
                result[p.no] = {mdown, _down(down).second};
            if (mup < result[p.no].first)
                result[p.no] = {mup, _up(up).second};
            if (i > 0 && p.x == pts[i - 1].x && abs(p.y - pts[i - 1].y) < result[p.no].first)
                result[p.no] = {abs(p.y - pts[i - 1].y), pts[i - 1].no};

            root = merge(down, up);
            insert(root, new node(p));
        }
    };

    walk();
    reverse(all(pts));
    for (auto &p : pts) p.x = LIM - p.x;
    walk();

    for (int i = 0; i < n; i++) {
        cout << result[i].second + 1 << ' ';
    }
    cout << '\n';

}