#include "testlib.h"
using namespace std;
typedef long long ll;


const ll maxR = 10'000;
const ll maxX = 10'000;
const ll maxY = 10'000;
const ll maxCoef = 10'000;

ll dist(ll x1, ll y1, ll x2, ll y2) {
    return (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2);
}

void genIn() {
    ll cx = rnd.next(-maxX, maxX);
    ll cy = rnd.next(-maxY, maxY);
    ll x1, y1, x2, y2;
    ll dis = 0;
    while (true) {
        x1 = rnd.next(-maxX, maxX);
        y1 = rnd.next(-maxY, maxY);
        x2 = rnd.next(-maxX, maxX);
        y2 = rnd.next(-maxY, maxY);
        if (max(dist(cx, cy, x1, y1), dist(cx, cy, x2, y2)) <= 1e8) {
            dis = max(dist(cx, cy, x1, y1), dist(cx, cy, x2, y2));
            break;
        }
    }
    cout << cx << ' ' << cy << ' ';
    cout << rnd.next((ll)ceil(sqrt(dis)), maxR) << '\n';

    cout << rnd.next(-maxCoef, maxCoef) << ' ';
    cout << rnd.next(-maxCoef, maxCoef) << ' ';
    cout << rnd.next(-maxCoef, maxCoef) << '\n';

    cout << x1 << ' ' << y1 << '\n';

    cout << x2 << ' ' << y2 << '\n';

}

void genOutYes() {
    ll cx = rnd.next(-maxX, maxX);
    ll cy = rnd.next(-maxY, maxY);
    ll x1, y1, x2, y2;
    ll dis = 0;
    x1 = rnd.next(-maxX, maxX);
    y1 = rnd.next(-maxY, maxY);
    x2 = rnd.next(-maxX, maxX);
    y2 = rnd.next(-maxY, maxY);
    dis = min(dist(cx, cy, x1, y1), dist(cx, cy, x2, y2));

    cout << cx << ' ' << cy << ' ';
    cout << rnd.next(0ll, (ll) ceil(sqrt(dis))) << '\n';

    ll A = y2 - y1;
    ll B = x1 - x2;
    ll gcd = __gcd(A, B);
    A /= gcd;
    B /= gcd;

    ll k = rnd.next(-maxCoef / max(abs(A), abs(B)), maxCoef / max(abs(A), abs(B)));

    cout << k * A << ' ';
    cout << k * B << ' ';
    cout << rnd.next(-maxCoef, maxCoef) << '\n';

    cout << x1 << ' ' << y1 << '\n';

    cout << x2 << ' ' << y2 << '\n';

}

void genOutNo() {
    ll cx = rnd.next(-maxX, maxX);
    ll cy = rnd.next(-maxY, maxY);
    ll x1, y1, x2, y2;
    ll dis = 0;
    x1 = rnd.next(-maxX, maxX);
    y1 = rnd.next(-maxY, maxY);
    x2 = rnd.next(-maxX, maxX);
    y2 = rnd.next(-maxY, maxY);
    dis = min(dist(cx, cy, x1, y1), dist(cx, cy, x2, y2));

    cout << cx << ' ' << cy << ' ';
    cout << rnd.next(0ll, (ll) ceil(sqrt(dis))) << '\n';

    cout << rnd.next(-maxCoef, maxCoef) << ' ';
    cout << rnd.next(-maxCoef, maxCoef) << ' ';
    cout << rnd.next(-maxCoef, maxCoef) << '\n';

    cout << x1 << ' ' << y1 << '\n';

    cout << x2 << ' ' << y2 << '\n';

}

void gen() {
    ll cx = rnd.next(-maxX, maxX);
    ll cy = rnd.next(-maxY, maxY);
    ll x1, y1, x2, y2;
    ll disMin = 0, disMax = 0;
    x1 = rnd.next(-maxX, maxX);
    y1 = rnd.next(-maxY, maxY);
    x2 = rnd.next(-maxX, maxX);
    y2 = rnd.next(-maxY, maxY);
    disMin = min(dist(cx, cy, x1, y1), dist(cx, cy, x2, y2));
    disMax = max(dist(cx, cy, x1, y1), dist(cx, cy, x2, y2));


    cout << cx << ' ' << cy << ' ';
    cout << rnd.next(min(disMin, maxR), min(disMax, maxR)) << '\n';

    cout << rnd.next(-maxCoef, maxCoef) << ' ';
    cout << rnd.next(-maxCoef, maxCoef) << ' ';
    cout << rnd.next(-maxCoef, maxCoef) << '\n';

    cout << x1 << ' ' << y1 << '\n';

    cout << x2 << ' ' << y2 << '\n';
}

void genRandom() {
    cout << rnd.next(-maxX, maxX) << ' ';
    cout << rnd.next(-maxY, maxY) << ' ';
    cout << rnd.next(0ll, maxR) << '\n';

    cout << rnd.next(-maxCoef, maxCoef) << ' ';
    cout << rnd.next(-maxCoef, maxCoef) << ' ';
    cout << rnd.next(-maxCoef, maxCoef) << '\n';

    cout << rnd.next(-maxX, maxX) << ' ';
    cout << rnd.next(-maxY, maxY) << '\n';

    cout << rnd.next(-maxX, maxX) << ' ';
    cout << rnd.next(-maxY, maxY) << '\n';
}

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);

    string type = argv[1];
    if (type == "in") {
        genIn();
    } else if (type == "out_yes") {
        genOutYes();
    } else if (type == "out_no") {
        genOutYes();
    } else if (type == "rnd") {
        genRandom();
    } else {
        gen();
    }
    return 0;
}
