#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

#define all(c) c.begin(), c.end()

struct node;
typedef node *nodeptr;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 mt_rand(seed);
auto randint = uniform_int_distribution<int>(-1e9, 1e9);

struct node {
    nodeptr l = nullptr, r = nullptr;
    int size = 1, y, spaces, last_space;
    char value;

    node(char c) : y(randint(mt_rand)), spaces(c == ' '), value(c) {
        last_space = c == ' ' ? 0 : -1;
    }
};

inline int _size(nodeptr root) {
    return root ? root->size : 0;
}

inline int _spaces(nodeptr root) {
    return root ? root->spaces : 0;
}

inline int _last_space(nodeptr root) {
    return root ? root->last_space : -1;
}

nodeptr recalc(nodeptr root) {
    if (!root) return nullptr;
    root->size = 1 + _size(root->l) + _size(root->r);
    root->spaces = _spaces(root->l) + _spaces(root->r) + (root->value == ' ');
    root->last_space = _last_space(root->l);
    if (root->value == ' ') root->last_space = _size(root->l);
    if (_last_space(root->r) > -1) root->last_space = _size(root->l) + 1 + _last_space(root->r);
    return root;
}

pair<nodeptr, nodeptr> split(nodeptr root, int size) {
    if (!root) return {nullptr, nullptr};
    int lsize = _size(root->l);
    if (lsize < size) {
        auto [l, r] = split(root->r, size - lsize - 1);
        root->r = l;
        return {recalc(root), r};
    } else {
        auto [l, r] = split(root->l, size);
        root->l = r;
        return {l, recalc(root)};
    }
}

nodeptr merge(nodeptr l, nodeptr r) {
    if (!l) return r;
    if (!r) return l;
    if (l->y > r->y) {
        l->r = merge(l->r, r);
        return recalc(l);
    } else {
        r->l = merge(l, r->l);
        return recalc(r);
    }
}

nodeptr search(nodeptr root, int order) {
    int lsize = _size(root->l);
    if (order < lsize) return search(root->l, order);
    if (order > lsize) return search(root->r, order - lsize - 1);
    return root;
}

int search_space(nodeptr root, int order) {
    int lspaces = _spaces(root->l);
    if (order < lspaces) return search_space(root->l, order);
    if (order > lspaces) return search_space(root->r, order - lspaces - (root->value == ' ')) + _size(root->l) + 1;
    return _last_space(root->l);
}

int space_count(nodeptr root, int order) {
    int lsize = _size(root->l);
    if (order < lsize) return space_count(root->l, order);
    if (order > lsize) return space_count(root->r, order - lsize - 1) + _spaces(root->l) + (root->value == ' ');
    return _spaces(root->l);
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    in(int, n, m)
    nodeptr root = nullptr;
    for (int i = 0; i < n; i++) {
        if (i > 0) root = merge(root, new node(' '));
        in(string, word)
        for (char c : word) root = merge(root, new node(c));
    }

    for (int q = 0; q < m; q++) {
        in(string, type);
        if (type == "?1") {
            in(int, index);
            auto [l, r] = split(root, --index);
            int w = _spaces(l) + 1, p = index - _last_space(l);
            cout << w << " " << p << '\n';
            root = merge(l, r);
        } else if (type == "?2") {
            in(int, w, p)
            int index = search_space(root, --w);
            cout << index + p + 1 << '\n';
        } else if (type == "+") {
            in(int, index)
            in(char, c)
            if (c == '_') c = ' ';
            auto [l, r] = split(root, --index);
            root = merge(merge(l, new node(c)), r);
        } else {
            in(int, index)
            auto [l, tmp] = split(root, --index);
            auto [node, r] = split(tmp, 1);
            root = merge(l, r);
        }
    }

}